(*
  Autor" Alojz Bendak 2006
*)
unit figureutils;

interface

uses
  Graphics, Windows;

const
  FieldOffsetX = 0;
  FieldOffsetY = FieldOffsetX;

  FieldLeft = 10;
  FieldTop = FieldLeft;

  FieldWidth = 10;
  FieldHeight = 24;

  BarWidth = 16;
  BarHeight = BarWidth;

  FigureScore: array [1..7] of integer = (30, 40, 40, 50, 50, 10, 20);  

type
  PField = ^TField;
  TField = array [1..FieldWidth, 1..FieldHeight] of boolean;

  TMoveDirect=  (mdDown, mdLeft, mdRight);

  TFigureObjectType = (None, Triada, LeftCorner, RightCorner, LeftZikZak, RightZikZak, Stick, Box);

  TRotatedType = (Rot0, Rot90, Rot180, Rot270);

  TParts = array [1..4, 1..4] of boolean;

  TFigureColor = record
                   FigureColor: TColor;
                   FigureBorderColor: TColor;
                 end;

  TRandomColors = array [1..7] of TFigureColor;

var
  RandomColors: TRandomColors;

function GetRandomIndex: integer;

implementation

var
  ColorIndexes: array of integer;

function GetRandomIndex: integer;

   function IsInArray(index: integer): boolean;
   var
     i: integer;
   begin
     for i := 0 to High(ColorIndexes) do
       if ColorIndexes[i] = index then
       begin
         Result := true;
         exit;
       end;
     Result := false;
   end;

var
  ColorIndex: integer;
begin
  if (Length(ColorIndexes) = 7) or (Length(ColorIndexes) = 0) then
  begin
    SetLength(ColorIndexes, 1);
    ColorIndexes[0] := 0;
  end
  else
    SetLength(ColorIndexes, Length(ColorIndexes) + 1);

  repeat
    ColorIndex := Random(7) + 1;
  until not IsInArray(ColorIndex);

  ColorIndexes[High(ColorIndexes)] := ColorIndex;
  Result := ColorIndex;
end;

initialization
  RandomColors[1].FigureColor := RGB(255, 0, 0);
  RandomColors[1].FigureBorderColor := RGB(213, 0, 0);

  RandomColors[2].FigureColor := RGB(0, 128, 255);
  RandomColors[2].FigureBorderColor := RGB(0, 64, 128);

  RandomColors[3].FigureColor := RGB(255, 255, 0);
  RandomColors[3].FigureBorderColor := RGB(151, 151, 0);

  RandomColors[4].FigureColor := RGB(0, 255, 0);
  RandomColors[4].FigureBorderColor := RGB(0, 64, 0);

  RandomColors[5].FigureColor := RGB(255, 128, 255);
  RandomColors[5].FigureBorderColor := RGB(128, 0, 64);

  RandomColors[6].FigureColor := RGB(128, 255, 255);
  RandomColors[6].FigureBorderColor := RGB(0, 94, 94);

  RandomColors[7].FigureColor := RGB(255, 128, 0);
  RandomColors[7].FigureBorderColor := RGB(119, 60, 0);
end.
