(*
  Autor" Alojz Bendak 2006
*)
unit tetriswindow;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons, ComCtrls, figureobject,
  figureutils, jpeg;

type

  TFigureObjects = array of TFigureObject;

  TTertis = class(TForm)                                                                  
    Timer1: TTimer;
    Bevel3: TBevel;
    KoniecLabel: TLabel;
    PauzaLabel: TLabel;
    Bevel2: TBevel;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    Bevel4: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    Level: integer;
    LevelScore: integer;
    AllScore: integer;
    ActiveProcess: boolean;
    LastFigureObjectType: TFigureObjectType;
    FigureObjectBefore: TFigureObject;
    ActiveFigureObject: TFigureObject;
    FigureObjects: TFigureObjects;
    BackBitmap: Graphics.TBitmap;
    RightBitmap: Graphics.TBitmap;
    Field: TField;
    procedure PutScore(Value: integer; Start: boolean);
    function CheckFigureObjects: boolean;
    function CreateNewObject: TFigureObject;
    procedure PutObjectIntoRow(FigureObject: TFigureObject);
    procedure CleanAllObjects;
    procedure DrawFigureObjects(DrawOnForm: boolean);
    procedure DrawFigureObjectsBefore(DrawOnForm: boolean);
  public

  end;

var
  Tertis: TTertis;

implementation

uses
  funkcie, Windows;

{$R *.DFM}

procedure TTertis.FormCreate(Sender: TObject);
begin
  Randomize;

  BackBitmap := Graphics.TBitmap.Create;
  BackBitmap.PixelFormat := pf16bit;
  BackBitmap.Height := FieldHeight * BarHeight + 2 * FieldOffsetY;
  BackBitmap.Width := FieldWidth * BarWidth + 2 * FieldOffsetX;

  RightBitmap := Graphics.TBitmap.Create;
  RightBitmap.PixelFormat := pf16bit;
  RightBitmap.Height := Bevel4.Height - 4;
  RightBitmap.Width := Bevel4.Width - 4;

  Bevel3.Left := FieldLeft - 2;
  Bevel3.Top := FieldTop - 2;
  Bevel3.Height := 2 * FieldOffsetY + FieldHeight * BarHeight + 5;
  Bevel3.Width := 2 * FieldOffsetX + FieldWidth * BarWidth + 5;

  ClientHeight := Bevel3.Height + 2 * FieldTop;
  ClientWidth := 3 * Bevel3.Left + Bevel3.Width + SpeedButton5.Width;

  ActiveProcess := false;

  FigureObjectBefore := Nil;
  ActiveFigureObject := Nil;
  
  DrawFigureObjects(false);
  DrawFigureObjectsBefore(false);
end;

procedure TTertis.FormDestroy(Sender: TObject);
begin
  BackBitmap.Free;
  RightBitmap.Free;
end;

procedure TTertis.FormPaint(Sender: TObject);
begin
  Canvas.Draw(FieldLeft, FieldTop, BackBitmap);
  Canvas.Draw(Bevel4.Left + 2, Bevel4.Top + 2, RightBitmap);
end;

procedure TTertis.DrawFigureObjects(DrawOnForm: boolean);
var
  i: integer;
  FigureObject: TFigureObject;
begin
  BackBitmap.Canvas.Brush.Color := clBlack;
  BackBitmap.Canvas.FillRect(BackBitmap.Canvas.ClipRect);
  for i := 0 to High(FigureObjects) do
  begin
    FigureObject := FigureObjects[i];
    FigureObject.Draw;
  end;
  if DrawOnForm then
    Canvas.Draw(FieldLeft, FieldTop, BackBitmap);
end;

procedure TTertis.DrawFigureObjectsBefore(DrawOnForm: boolean);
begin
  RightBitmap.Canvas.Brush.Color := clBlack;
  RightBitmap.Canvas.FillRect(RightBitmap.Canvas.ClipRect);
  if Assigned(FigureObjectBefore) then
    FigureObjectBefore.Draw;
  if DrawOnForm then
    Canvas.Draw(Bevel4.Left + 2, Bevel4.Top + 2, RightBitmap);
end;

procedure TTertis.SpeedButton5Click(Sender: TObject);
begin
  Timer1.Interval := 750;
  LastFigureObjectType := None;
  ActiveFigureObject := Nil;
  CleanAllObjects;
  Timer1.Enabled := true;
  SpeedButton5.Enabled := false;
  SpeedButton6.Enabled := true;
  SpeedButton7.Enabled := true;
  SpeedButton1.Enabled := true;
  SpeedButton2.Enabled := true;
  SpeedButton3.Enabled := true;
  SpeedButton4.Enabled := true;
  SpeedButton8.Enabled := true;
  KoniecLabel.Visible := false;
  PutScore(0, true);
end;

procedure TTertis.Timer1Timer(Sender: TObject);
begin
  if ActiveProcess then
    exit;

  ActiveProcess := true;
  if Assigned(ActiveFigureObject) and ActiveFigureObject.CanGoDown then
    ActiveFigureObject.DoStepDown
  else
  begin
    CheckFigureObjects;

    if Assigned(FigureObjectBefore) then
    begin
      ActiveFigureObject := FigureObjectBefore;
      FigureObjectBefore := CreateNewObject;
    end
    else
    begin
      FigureObjectBefore := CreateNewObject;
      ActiveFigureObject := CreateNewObject;
    end;
    PutObjectIntoRow(ActiveFigureObject);

    if ActiveFigureObject.CanPut and ActiveFigureObject.CanGoDown then
    begin
      PutScore(ActiveFigureObject.Score, false);
    end
    else
    begin
      DrawFigureObjects(true);
      WaitProcMes(1000);
      SpeedButton7.Click;
      KoniecLabel.Visible := true;
      ActiveProcess := false;
      exit;
    end;
  end;

  DrawFigureObjectsBefore(true);
  DrawFigureObjects(true);
  Application.ProcessMessages;
  ActiveProcess := false;
end;

function TTertis.CreateNewObject: TFigureObject;
var
  FigureObject: TFigureObject;
  ColorIndex: integer;
begin
  FigureObject := TFigureObject.Create;
  repeat
    FigureObject.FigureObjectType := TFigureObjectType(Random(7) + 1);
  until FigureObject.FigureObjectType <> LastFigureObjectType;
  LastFigureObjectType := FigureObject.FigureObjectType;
  FigureObject.FigureRotated := TRotatedType(Random(4));
  ColorIndex := GetRandomIndex;
  FigureObject.Color := RandomColors[ColorIndex].FigureColor;
  FigureObject.BorderColor := RandomColors[ColorIndex].FigureBorderColor;
  FigureObject.Canvas := RightBitmap.Canvas;
  FigureObject.Top := 2;
  FigureObject.Left := ((RightBitmap.Width div BarWidth + 1) - FigureObject.Width) div 2 + 1;
  if FigureObject.Left < 1 then
    FigureObject.Left := 1;
  Result := FigureObject;
end;

procedure TTertis.PutObjectIntoRow(FigureObject: TFigureObject);
begin
  FigureObject.Top := 1;
  FigureObject.Left := Random(FieldWidth - FigureObject.Width + 1) + 1;
  FigureObject.ParentField := @Field;
  FigureObject.Canvas := BackBitmap.Canvas;
  SetLength(FigureObjects, Length(FigureObjects) + 1);
  FigureObjects[High(FigureObjects)] := FigureObject;
end;

procedure TTertis.SpeedButton7Click(Sender: TObject);
begin
  Timer1.Enabled := false;
  CleanAllObjects;
  DrawFigureObjectsBefore(true);
  DrawFigureObjects(true);
  SpeedButton5.Enabled := true;
  SpeedButton6.Enabled := false;
  SpeedButton6.Caption := '&Pauza';
  SpeedButton7.Enabled := false;
  SpeedButton1.Enabled := false;
  SpeedButton2.Enabled := false;
  SpeedButton3.Enabled := false;
  SpeedButton4.Enabled := false;
  SpeedButton8.Enabled := false;
end;

procedure TTertis.CleanAllObjects;
var
  i: integer;
begin
  FillChar(Field, SizeOf(Field), false);
  for i := 0 to High(FigureObjects) do
    FigureObjects[i].Free;
  SetLength(FigureObjects, 0);
  ActiveFigureObject := Nil;
  if Assigned(FigureObjectBefore) then
  begin
    FigureObjectBefore.Free;
    FigureObjectBefore := Nil;
  end;
end;

procedure TTertis.SpeedButton2Click(Sender: TObject);
begin
  if Assigned(ActiveFigureObject) and ActiveFigureObject.CanRotate(true) then
  begin
    ActiveFigureObject.DoRotate(true);
    DrawFigureObjects(true);
  end;
end;

procedure TTertis.SpeedButton8Click(Sender: TObject);
begin
  if Assigned(ActiveFigureObject) and ActiveFigureObject.CanRotate(false) then
  begin
    ActiveFigureObject.DoRotate(false);
    DrawFigureObjects(true);
  end;
end;

procedure TTertis.SpeedButton3Click(Sender: TObject);
begin
  if Assigned(ActiveFigureObject) and ActiveFigureObject.CanGoToRight then
  begin
    ActiveFigureObject.DoStepRight;
    DrawFigureObjects(true);
  end;
end;

procedure TTertis.SpeedButton1Click(Sender: TObject);
begin
  if Assigned(ActiveFigureObject) and ActiveFigureObject.CanGoToLeft then
  begin
    ActiveFigureObject.DoStepLeft;
    DrawFigureObjects(true);
  end;
end;

procedure TTertis.SpeedButton4Click(Sender: TObject);
begin
  if Assigned(ActiveFigureObject) then
  begin
    while ActiveFigureObject.CanGoDown do
      ActiveFigureObject.DoStepDown;
    DrawFigureObjects(true);
    if CheckFigureObjects then
    begin
      Wait(500);
      DrawFigureObjects(true);
    end;  
  end;
end;

function TTertis.CheckFigureObjects: boolean;

  function IsCleanLine(var Line: integer): integer;
  var
    i, j: integer;
    IsClean: boolean;
  begin
    for j := FieldHeight downto 1 do
    begin
      IsClean := true;
      for i := 1 to FieldWidth do
      begin
        if not Field[i, j] then
        begin
          IsClean := false;
          break;
        end;
      end;
      if IsClean then
      begin
        Line := j;
        Result := j;
        exit;
      end;
    end;
    Result := 0;
    Line := 0;
  end;

var
  Line: integer;
  FigureObject: TFigureObject;
  i, j: integer;
  ScorePart: integer;
  TempArray: TFigureObjects;
begin
  Result := false;
  ScorePart := 0;
  while IsCleanLine(Line) > 0 do
  begin
    for i := 0 to High(FigureObjects) do
    begin
      FigureObject := FigureObjects[i];
      if Assigned(FigureObject) then
      begin
        if (Line >= FigureObject.Top) and (Line < FigureObject.Top + FigureObject.Height) then
        begin
          Result := true;
          FigureObject.ReduceLine(Line);
          if FigureObject.Empty then
          begin
            if FigureObject = ActiveFigureObject then
              ActiveFigureObject := Nil;
            FigureObject.Free;
            FigureObjects[i] := Nil;
          end
          else
            FigureObject.DoStepDown;
        end
        else if FigureObject.Top < Line then
          FigureObject.DoStepDown;
      end;
    end;
    Inc(ScorePart);
  end;

  j := -1;
  SetLength(TempArray, Length(FigureObjects));
  for i := 0 to High(FigureObjects) do
    if Assigned(FigureObjects[i]) then
    begin
      Inc(j);
      TempArray[j] := FigureObjects[i];
    end;
  SetLength(FigureObjects, j + 1);
  for i := 0 to High(FigureObjects) do
    FigureObjects[i] := TempArray[i];

  PutScore(100 * ScorePart, false);
end;

procedure TTertis.SpeedButton6Click(Sender: TObject);
begin
  Timer1.Enabled := not Timer1.Enabled;
  if Timer1.Enabled then
  begin
    SpeedButton6.Caption := '&Pauza';
    PauzaLabel.Visible := false;
  end
  else
  begin
    SpeedButton6.Caption := '&Pokraova';
    PauzaLabel.Visible := true;
  end;
  SpeedButton1.Enabled := Timer1.Enabled;
  SpeedButton2.Enabled := Timer1.Enabled;
  SpeedButton3.Enabled := Timer1.Enabled;
  SpeedButton4.Enabled := Timer1.Enabled;
  SpeedButton8.Enabled := Timer1.Enabled;
end;

procedure TTertis.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if Timer1.Enabled then
  begin
    SpeedButton6.Click;
    CanClose := DefMessageDlg('Otzka', 'Naozaj chcete koniec hry?', mtConfirmation, [mbNo, mbYes], idNo, 0) = idYes;
    if not CanClose then
      SpeedButton6.Click;
  end
  else
    CanClose := true;
end;

procedure TTertis.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: Close;
    VK_LEFT: SpeedButton1.Click;
    VK_RIGHT: SpeedButton3.Click;
    VK_DOWN, VK_SPACE: SpeedButton4.Click;
    188: SpeedButton8.Click;
    190: SpeedButton2.Click;
  end;
end;

procedure TTertis.PutScore(Value: integer; Start: boolean);
begin
  if Start then
  begin
    AllScore := 0;
    LevelScore := 0;
    Level := 1;
  end
  else
  begin
    Inc(AllScore, Value);
    Inc(LevelScore, Value);
    if LevelScore > 1000 then
    begin
      if Timer1.Interval > 100 then
        Timer1.Interval := Timer1.Interval - 50;
      Inc(Level);
      LevelScore := 0;
    end;
  end;
  Label4.Caption := IntToStr(AllScore);
  Label3.Caption := IntToStr(Level);
end;

end.
